diff -urN sourceold/scripts/BuildingGameObj.h source/scripts/BuildingGameObj.h
--- sourceold/scripts/BuildingGameObj.h	2018-11-17 10:23:56.965600000 +1000
+++ source/scripts/BuildingGameObj.h	2020-03-28 21:10:59.007874300 +1000
@@ -107,6 +107,7 @@
 #endif
 	SCRIPTS_API void											Find_Closest_Poly (const Vector3 &pos, float *distance2);
 	float Find_Closest_Poly(const Vector3 &pos) { float distance2; Find_Closest_Poly(pos,&distance2); return distance2; }
+	void Find_Closest_Poly(const Vector3& pos, float* distance2, Vector3* polyPos);
 	int											Building_In_Range(const Vector3 &point, float range);	//return 0 for no, 1 for yes and 2 for MCT in range
 	bool										Is_In_Range_Coarse(const Vector3& point, float range_sq);
 	bool Cast_Ray(RayCollisionTestClass& raytest);
@@ -145,7 +146,7 @@
 	void											Add_Aggregate(BuildingAggregateClass * aggregate);
 	void											Remove_Aggregate(BuildingAggregateClass * aggregate);
 	void											Add_Light(LightPhysClass * light);
-	void											Find_Closest_Poly_For_Model (RenderObjClass *model, const Vector3 &pos, float *distance2);
+	void											Find_Closest_Poly_For_Model (RenderObjClass *model, const Vector3 &pos, float *distance2, Vector3* polyPos = NULL);
 	void											Update_State(bool force_update = false);
 	void											Enable_Alternate_Materials(RefMultiListClass<StaticPhysClass> & models, bool onoff);
 	void											Enable_Alternate_Materials(RenderObjClass * model,bool onoff);
diff -urN sourceold/scripts/Defines.h source/scripts/Defines.h
--- sourceold/scripts/Defines.h	2018-11-17 10:23:56.993600000 +1000
+++ source/scripts/Defines.h	2020-09-26 09:00:03.275362600 +1000
@@ -30,6 +30,7 @@
 #pragma warning(disable:4251)
 
 #define WIN32_LEAN_AND_MEAN
+#define _WIN32_WINNT 0x0601
 #define _USE_MATH_DEFINES
 
 // breakpoint
diff -urN sourceold/scripts/Doxyfile source/scripts/Doxyfile
--- sourceold/scripts/Doxyfile	2018-11-17 10:23:57.001600000 +1000
+++ source/scripts/Doxyfile	2020-04-02 12:02:44.436401100 +1000
@@ -32,7 +32,7 @@
 # This could be handy for archiving the generated documentation or
 # if some version control system is used.
 
-PROJECT_NUMBER         = 4.6
+PROJECT_NUMBER         = 4.7
 # Using the PROJECT_BRIEF tag one can provide an optional one line description
 # for a project that appears at the top of each page and should give viewer
 # a quick idea about the purpose of the project. Keep the description short.
diff -urN sourceold/scripts/HumanStateClass.h source/scripts/HumanStateClass.h
--- sourceold/scripts/HumanStateClass.h	2018-11-17 10:23:57.015600000 +1000
+++ source/scripts/HumanStateClass.h	2020-09-10 09:08:27.945919000 +1000
@@ -160,6 +160,7 @@
 	void					Update_Recoil(WeaponClass * weapon);
 	void					Begin_Jump( void );
 	void					Complete_Jump( void );
+	void					GetLegAndHoldStyle (int *leg_style,int *hold_style);
 };
 
 
diff -urN sourceold/scripts/LineSegClass.cpp source/scripts/LineSegClass.cpp
--- sourceold/scripts/LineSegClass.cpp	2018-11-17 10:23:57.023600000 +1000
+++ source/scripts/LineSegClass.cpp	2020-09-10 09:08:27.946909600 +1000
@@ -34,6 +34,7 @@
     Matrix3D::Transform_Vector(transform, object.P1, &P1);
     DP = P1 - P0;
     Matrix3D::Rotate_Vector(transform, object.Dir, &Dir);
+	Length = object.Length;
 }
 
 bool LineSegClass::Find_Intersection(const LineSegClass &other_line, Vector3 *p1, float *fraction1, Vector3 *p2, float *fraction2) const
diff -urN sourceold/scripts/ObjectLibraryManager.cpp source/scripts/ObjectLibraryManager.cpp
--- sourceold/scripts/ObjectLibraryManager.cpp	1970-01-01 10:00:00.000000000 +1000
+++ source/scripts/ObjectLibraryManager.cpp	2020-03-28 21:10:59.056743700 +1000
@@ -0,0 +1,31 @@
+#include "general.h"
+
+#include "ObjectLibraryManager.h"
+#include "DefinitionMgrClass.h"
+#include "Definition.h"
+PhysicalGameObj* ObjectLibraryManager::Create_Object
+   (const char* cPresetName)
+{
+   // const DefinitionClass* oDefinition = DefinitionMgrClass::Find_Typed_Definition (cPresetName, 12288, true);
+   DefinitionClass* oDefinition = DefinitionMgrClass::Find_Named_Definition (cPresetName, true);
+
+   StringClass oError;
+   if (!oDefinition || !oDefinition->Is_Valid_Config (oError))
+      return 0;
+
+   return (PhysicalGameObj *)oDefinition->Create();
+}
+
+
+
+PhysicalGameObj* ObjectLibraryManager::Create_Object
+   (uint32 uDefinitionID)
+{
+   DefinitionClass* oDefinition = DefinitionMgrClass::Find_Definition (uDefinitionID, true);
+
+   StringClass oError;
+   if (!oDefinition || !oDefinition->Is_Valid_Config (oError))
+      return 0;
+
+   return (PhysicalGameObj *)oDefinition->Create();
+}
diff -urN sourceold/scripts/ObjectLibraryManager.h source/scripts/ObjectLibraryManager.h
--- sourceold/scripts/ObjectLibraryManager.h	1970-01-01 10:00:00.000000000 +1000
+++ source/scripts/ObjectLibraryManager.h	2020-03-28 21:10:59.056743700 +1000
@@ -0,0 +1,16 @@
+#ifndef TT_INCLUDE__OBJECTLIBRARYMANAGER_H
+#define TT_INCLUDE__OBJECTLIBRARYMANAGER_H
+#include "Persist.h"
+class PhysicalGameObj;
+class ObjectLibraryManager
+{
+
+public:
+
+   static PhysicalGameObj* Create_Object (const char* cPresetName);
+   static PhysicalGameObj* Create_Object (uint32 uDefinitionID);
+
+};
+
+
+#endif
diff -urN sourceold/scripts/RefineryGameObj.h source/scripts/RefineryGameObj.h
--- sourceold/scripts/RefineryGameObj.h	2018-11-17 10:23:57.068600000 +1000
+++ source/scripts/RefineryGameObj.h	2020-09-10 09:08:27.946909600 +1000
@@ -61,6 +61,7 @@
 	{
 		AllowHarvesterSpawn = true;
 	}
+	static float HarvesterDumpRate;
 private:
 	void					Load_Variables (ChunkLoadClass &cload);	
 	HarvesterClass *	Harvester;
@@ -75,6 +76,8 @@
 	AudibleSoundClass * MoneyTrickleSound;
 	bool					AllowHarvesterSpawn;
 	ReferencerClass HarvesterVehicle;
+	float accumulatedDumpCredits;
+	float DumpRate;
 }; // 2232, RH7 2252
 
 
diff -urN sourceold/scripts/RefineryGameObjDef.h source/scripts/RefineryGameObjDef.h
--- sourceold/scripts/RefineryGameObjDef.h	2018-11-17 10:23:57.068600000 +1000
+++ source/scripts/RefineryGameObjDef.h	2020-03-28 21:10:59.012889300 +1000
@@ -22,6 +22,8 @@
 	~RefineryGameObjDef (void);
 	uint32								Get_Class_ID (void) const;
 	PersistClass *						Create (void) const;
+	float								Get_Funds_Gathered() const { return FundsGathered; }
+	float								Get_Funds_Distributed_Per_Sec() const { return FundsDistributedPerSec; }
 	bool									Save (ChunkSaveClass &csave);
 	bool									Load (ChunkLoadClass &cload);
 	const PersistFactoryClass &	Get_Factory (void) const;
diff -urN sourceold/scripts/SmartGameObjDef.h source/scripts/SmartGameObjDef.h
--- sourceold/scripts/SmartGameObjDef.h	2018-11-17 10:23:57.086600000 +1000
+++ source/scripts/SmartGameObjDef.h	2020-09-10 09:08:27.947906000 +1000
@@ -26,6 +26,12 @@
 	virtual bool								Save( ChunkSaveClass &csave );
 	virtual bool								Load( ChunkLoadClass &cload );
 	bool Is_Stealthed() const {return IsStealthUnit;}
+	/* Modifies the sight range of the object. SightRange is used by AI code only. */
+	void Set_Sight_Range (const float range) { SightRange = range; }
+	float Get_Sight_Range() const {return SightRange;}
+	/* Modifies the sight arc of the object. SightArc is used by AI code only. */
+	void Set_Sight_Arc (const float arc) { SightArc = arc; }
+	float Get_Sight_Arc() const {return SightArc;}
 #ifdef DDBEDIT
 	virtual void                        Dump (FileClass &file);
 #endif
diff -urN sourceold/scripts/SoldierGameObj.h source/scripts/SoldierGameObj.h
--- sourceold/scripts/SoldierGameObj.h	2019-06-22 07:31:28.791400000 +1000
+++ source/scripts/SoldierGameObj.h	2020-09-10 09:08:27.947906000 +1000
@@ -202,6 +202,9 @@
 	bool Get_Use_Stock_Ghost_Behavior(){return useStockGhostBehavior;}
 	void Set_Override_Muzzle_Direction(bool override){OverrideMuzzleDirection = override; Set_Object_Dirty_Bit(BIT_RARE, true);};
 	bool Get_Override_Muzzle_Direction(){return OverrideMuzzleDirection;};
+	void Set_Bot_Tag(const char* tag) { botTag = tag; Set_Object_Dirty_Bit(BIT_RARE, true); }
+	const WideStringClass& Get_Bot_Tag() { return botTag; }
+	bool Is_Bot() { return botTag.Get_Length() > 0; }
 	virtual int Get_Contact_Surface_Type();
 	virtual float		Get_Skeleton_Heigth( void );
 	virtual void 		Set_Skeleton_Height( float height );
@@ -288,6 +291,8 @@
 	float						lastSkeletonWidth;
 	int							overrideWeaponHoldStyleId;
 	bool						enableHumanAnimOverride;
+	WideStringClass				botTag;
+	int sight_bone;
 	TT_DEPRECATED("Do not use") int						Check(void);
 }; // size: 3404
 
diff -urN sourceold/scripts/SoundSceneObjClass.h source/scripts/SoundSceneObjClass.h
--- sourceold/scripts/SoundSceneObjClass.h	2018-10-27 22:04:56.326400000 +1000
+++ source/scripts/SoundSceneObjClass.h	2020-03-28 21:10:59.014855700 +1000
@@ -18,6 +18,9 @@
 #include "audiocallback.h"
 #include "Persist.h"
 #include "Matrix3D.h"
+#if !defined(W3DVIEWER) && !defined(TTLE_EXPORTS)
+#include "HashTemplateClass.h"
+#endif
 class SoundSceneClass;
 class SoundCullObjClass;
 class Sound3DClass;
@@ -28,6 +31,7 @@
 class RenderObjClass;
 const uint32	SOUND_OBJ_DEFAULT_ID	= 0;
 const uint32	SOUND_OBJ_START_ID	= 1000000000;
+
 class SoundSceneObjClass : public MultiListObjectClass, public PersistClass, public RefCountClass
 {
 public:
@@ -87,9 +91,23 @@
 	int								m_AttachedBone; // 0030  0048
 	uint32							m_UserData; // 0034  004C
 	RefCountClass *				m_UserObj; // 0038  0050
+
 	static uint32 m_NextAvailableID;
 	static DynamicVectorClass<SoundSceneObjClass *>	m_GlobalSoundList;
 	static CriticalSectionClass m_IDListMutex;
+
+	// Added by TT
+#if !defined(W3DVIEWER) && !defined(TTLE_EXPORTS)
+public:
+	static void Associate_Server_ID(SoundSceneObjClass* sound_obj, uint32 server_id);
+
+protected:
+	static HashTemplateClass<uint32, SoundSceneObjClass*> m_ServerGlobalSoundList;
+	static HashTemplateClass<uint32, uint32> m_ReversedServerGlobalSoundList;
+	static CriticalSectionClass m_ServerIDListMutex;
+
+	static bool Find_Server_Sound_Object(uint32 server_id_to_find, SoundSceneObjClass*& sound_obj);
+#endif
 }; // 003C  0054
 
 #endif
diff -urN sourceold/scripts/SysTimeClass.cpp source/scripts/SysTimeClass.cpp
--- sourceold/scripts/SysTimeClass.cpp	2018-11-17 10:23:57.099600000 +1000
+++ source/scripts/SysTimeClass.cpp	2020-09-10 09:08:27.948915200 +1000
@@ -32,7 +32,15 @@
       this->Reset();
    }
 
-   return timeGetTime() - this->uTimeInit;
+   unsigned int u = timeGetTime();
+   if (u <= uTimeInit)
+   {
+       return uTimeInitNeg + u;
+   }
+   else
+   {
+       return u - uTimeInit;
+   }
 }
 
 
diff -urN sourceold/scripts/TwiddlerClass.h source/scripts/TwiddlerClass.h
--- sourceold/scripts/TwiddlerClass.h	2018-11-17 10:23:57.112600000 +1000
+++ source/scripts/TwiddlerClass.h	2020-03-28 21:10:59.014855700 +1000
@@ -19,6 +19,7 @@
 	virtual DefinitionClass *Twiddle() const;
 	PersistClass *Create() const;
 	const PersistFactoryClass &Get_Factory() const;
+	const DynamicVectorClass<int>& Get_Definition_List() { return m_DefinitionList; }
 	bool Save(ChunkSaveClass &csave);
 	bool Load(ChunkLoadClass &cload);
 	bool Save_Variables(ChunkSaveClass &csave);
diff -urN sourceold/scripts/Vector3.h source/scripts/Vector3.h
--- sourceold/scripts/Vector3.h	2018-11-17 10:23:57.113600000 +1000
+++ source/scripts/Vector3.h	2020-09-10 09:08:27.948915200 +1000
@@ -327,9 +327,11 @@
 
 	TT_INLINE static float Distance(const Vector3 &p1, const Vector3 &p2)
 	{
-		Vector3	temp;
-		temp = p1 - p2;
-		return (temp.Length());
+		return (p1 - p2).Length();
+	}
+	TT_INLINE static float Distance_Squared(const Vector3 &p1, const Vector3 &p2)
+	{
+		return (p1 - p2).Length2();
 	}
 	TT_INLINE static void Lerp(const Vector3 &a, const Vector3 &b, float alpha,Vector3 *set_result)
 	{
diff -urN sourceold/scripts/VehicleGameObj.h source/scripts/VehicleGameObj.h
--- sourceold/scripts/VehicleGameObj.h	2019-06-22 07:31:28.793400000 +1000
+++ source/scripts/VehicleGameObj.h	2020-03-28 21:10:59.015853000 +1000
@@ -98,6 +98,7 @@
 	void	Update_Damage_Meshes( void );
 	float	Get_Squish_Velocity( void) { return Get_Definition().SquishVelocity; }
 	void Script_Enable_Transitions( bool enable )	{	TransitionsEnabled = enable; Create_And_Destroy_Transitions(); }
+	bool Get_Transitions_Enabled ( void ) { return TransitionsEnabled; }
 	static void Set_Precision(void);
 	static bool	Toggle_Target_Steering( void );
 	static void	Set_Target_Steering( bool onoff );
diff -urN sourceold/scripts/WWAudioClass.h source/scripts/WWAudioClass.h
--- sourceold/scripts/WWAudioClass.h	2018-10-27 22:04:56.358400000 +1000
+++ source/scripts/WWAudioClass.h	2020-03-28 21:10:59.016850200 +1000
@@ -198,6 +198,10 @@
 	AudibleSoundClass *	Create_Sound (int definition_id, RefCountClass *user_obj = NULL, uint32 user_data = 0, int classid_hint = CLASSID_3D);
 	AudibleSoundClass *	Create_Sound (const char *def_name, RefCountClass *user_obj = NULL, uint32 user_data = 0, int classid_hint = CLASSID_3D);
 	SoundSceneObjClass *	Find_Sound_Object (uint32 sound_obj_id);
+#if !defined(W3DVIEWER) && !defined(TTLE_EXPORTS)
+	SoundSceneObjClass* Find_Server_Sound_Object(uint32 server_sound_obj_id); // Added by TT
+	uint32 Get_New_Server_Sound_ID(); // Added by TT
+#endif
 	SoundSceneClass *	Get_Sound_Scene (void) const		{ return m_SoundScene; }
 	bool					Set_Cache_Size (int kbytes = DEF_CACHE_SIZE)	{ m_MaxCacheSize = (kbytes * 1024); }
 	int					Get_Cache_Size (void) const						{ return m_MaxCacheSize / 1024; }
diff -urN sourceold/scripts/anticheat.ini source/scripts/anticheat.ini
--- sourceold/scripts/anticheat.ini	2018-11-17 10:23:37.857600000 +1000
+++ source/scripts/anticheat.ini	2020-09-26 08:59:57.386159600 +1000
@@ -134,3 +134,63 @@
 185315cb0070e52ab9c89d95d06f05e5=C&C_Complex.ldd
 11fc8b1d6d70fbacbb18181618fc3964=c&c_field.mix
 b94a4486508afdc014c1ff3ea4f3d455=c&c_field.ldd
+b3b5a7faa502f747d3bc8ff5c63a99cb=M00_Tutorial.mix
+5da07b82073c698031b3bacdf286709c=M02.mix
+ceb5f647bec120fedffc9d9fc70f9ae6=M04.mix
+77e35ed03742c2a3916cae9baf6b119a=M07.mix
+72d92296beb9b14c1cd227e8ee592e19=M08.mix
+b3a1e43b578cd1f1899d920d9502b4e3=always.dat
+bbcd3fe6b90f81db7a55a1a214a75368=always.dbs
+f89d34c3bc56931a98aab08ad58d8ef1=c&c_city_flying.lsd
+7ddf27c53b4ff6e2a359f7e1b0fb9d2c=c&c_glacier_flying.ddb
+840a735015e5a5f97f9b595d27d6939e=c&c_glacier_flying.ldd
+9d5a1a6534e87623734592583ebd7514=c&c_glacier_flying.lsd
+908f10aa21b880481f00df979ee9ffc3=c&c_walls_flying.lsd
+e8a85eab76883e81ddf00c8a3832e62b=m09.dep
+d42dde72d9b33d70e27186d8576f7f28=m09.ldd
+3f313b1d45c289b4315b849613e24d5d=m09.lsd
+8a73e57ed8328458fc5b8e188431b58a=c&c_canyon.ldd
+3c2948416ae9ef87576244334dd96dcc=c&c_canyon.lsd
+fa8ec7d845fc98fa4e251c47ddda08ab=C&C_Canyon.mix
+b707c64d4ecbd8852a9203194ea870d6=c&c_city.ldd
+06cea509a508dbbe2a77a20837d8af1a=c&c_city.lsd
+66653f776fc48d86fab9bd4e7a79fa50=C&C_City.mix
+8980464e3794ee7814fa8e628a6bf03f=c&c_city_flying.ldd
+1d9c1184dcf889db9e89fa0f4cbbc2f3=c&c_city_flying.lsd
+3ae55a803f618419613d4f9449621311=C&C_City_Flying.mix
+e579475a79eb6064e850540dcdbc93db=c&c_complex.ldd
+1f65b69504fc5900583038f4878395b5=c&c_complex.lsd
+4874ba832f9244cec2fdb06298d84f28=C&C_Complex.mix
+1f384b687a76243972d041416e971dd7=c&c_field.ldd
+09c11621c186be319abc9c67bfb6c851=c&c_field.lsd
+48bff89bfedbe2dec0bed18d30419a5f=C&C_Field.mix
+3a15d5bee28c4d1efb49a80da9912971=c&c_glacier_flying.ddb
+ce8e22aafb5d126384ecde5d424c774c=c&c_glacier_flying.ldd
+10a0a9086ccb7885c6140f98f099084a=c&c_glacier_flying.lsd
+5fb74b0a88a3d17296ceb7eb01b48ecf=C&C_Glacier_Flying.mix
+2c827469432c744858076605522f3179=c&c_hourglass.ldd
+d165cb79cb5928e4235d325296affebd=c&c_hourglass.lsd
+df78d1b07d1a9e6982a2b059687a35be=C&C_Hourglass.mix
+22bb4baf876ba7dbd3500e7f7a6b06b4=c&c_islands.ldd
+0250e5ff5fc14d206b6047c8ce878fe9=c&c_islands.lsd
+4189d8309dd8af379cd6059c4161001b=C&C_Islands.mix
+d274bd131570e2c86ca9c1283740c316=c&c_mesa.ldd
+ae9f30a84b0addad158b9607d650d1a6=c&c_mesa.lsd
+1093a6bfa25597ae0b092e2ff0841e55=C&C_Mesa.mix
+b4b62db6b2b678e6280788c31be801a4=c&c_under.ldd
+d52da922114ee3815e3af8e14f8f3407=c&c_under.lsd
+5ff1b5861853e4dda9193f0de21c72ca=C&C_Under.mix
+681e7516692cb3b2573591f74b5a9d18=c&c_volcano.ldd
+b3fa999e7d40b378d57d7dacfba87f36=c&c_volcano.lsd
+0eb0f530b48926241cbea44a24ef6a6e=C&C_Volcano.mix
+c6e8f0e037a922caa4aeeed7d9e51400=C&C_Walls.ldd
+a44fe08c4400d45dfc7c26e545cc1c44=C&C_Walls.lsd
+3e9c2babf700a495f8403303ef6e1707=C&C_Walls.mix
+49cadbf6942f619922e2d9ef03b58e0e=C&C_Walls_Flying.ldd
+779dbe4cc96b4b75be0189699eeab597=C&C_Walls_Flying.lsd
+cedd5f9edf76b92a5f8af4099c1e2e0e=C&C_Walls_Flying.mix
+dbcbf16ad119e54b3f11d6fa44de2fcc=m09.dep
+504fa186ffab468a37a64fbd3ab26b37=m09.ldd
+9a1b58b2327389f8065f704dd6e4d8a0=m09.lsd
+9be4d74ee0deff8204e7091df81eeff4=M09.mix
+3cedfb2b7c127d456c37ff10c7cc65a8=always3.dat
diff -urN sourceold/scripts/dllmain.cpp source/scripts/dllmain.cpp
--- sourceold/scripts/dllmain.cpp	2019-06-22 07:43:44.225400000 +1000
+++ source/scripts/dllmain.cpp	2020-09-26 08:59:57.387156900 +1000
@@ -334,6 +334,9 @@
 	Retrieve_Waypaths = (rwpa)Address(tt,"Retrieve_Waypaths");
 	Retrieve_Waypoints = (rwpo)Address(tt,"Retrieve_Waypoints");
 	Get_Waypoint_Position = (gwp)Address(tt,"Get_Waypoint_Position");
+	Test_Raycast_Collision = (trc)Address(tt,"Test_Raycast_Collision");
+	Is_Inside_AABox = (iib)Address(tt,"Is_Inside_AABox");
+	Can_Generic_Soldier_Teleport = (cgst)Address(tt,"Can_Generic_Soldier_Teleport");
 	Create_Lightning = (cl)Address(tt,"Create_Lightning");
 	Set_Global_Stealth_Disable = (smie)Address(tt,"Set_Global_Stealth_Disable");
 	Get_Clouds = (gc) Address(tt, "Get_Clouds");
@@ -378,6 +381,39 @@
 	Cancel_Get_Pathfind_Distance = (cgpd)Address(tt,"Cancel_Get_Pathfind_Distance");
 	Get_Pathfind_Distance_Async = (gpda)Address(tt, "Get_Pathfind_Distance_Async");
 	Get_Pathfind_Distance_Blocking = (gpdb)Address(tt, "Get_Pathfind_Distance_Blocking");
+	Get_Multiplayer_Spawn_Location = (gmsl)Address(tt, "Get_Multiplayer_Spawn_Location");
+	Enable_Spawners_By_Name = (esbn)Address(tt, "Enable_Spawners_By_Name");
+	Is_Pathfind_Generated = (ipg)Address(tt, "Is_Pathfind_Generated");
+	Get_Closest_Pathfind_Spot = (gcps)Address(tt, "Get_Closest_Pathfind_Spot");
+	Get_Closest_Pathfind_Spot_Size = (gcpss)Address(tt, "Get_Closest_Pathfind_Spot_Size");
+	Get_Radio_Command_String = (grcs)Address(tt, "Get_Radio_Command_String");
+	Set_Emot_Icon = (sei)Address(tt, "Set_Emot_Icon");
+	Kill_Messages_Disabled = (kmd)Address(tt, "Kill_Messages_Disabled");
+	Is_Sidebar_Enabled = (ise)Address(tt, "Is_Sidebar_Enabled");
+	Is_Extras_Enabled = (iee)Address(tt, "Is_Extras_Enabled");
+	Can_Build_Ground = (cbg)Address(tt, "Can_Build_Ground");
+	Can_Build_Air = (cba)Address(tt, "Can_Build_Air");
+	Can_Build_Naval = (cbn)Address(tt, "Can_Build_Naval");
+	Is_Soldier_Busy = (isb)Address(tt, "Is_Soldier_Busy");
+	Is_On_Enemy_Pedestal = (ioep)Address(tt, "Is_On_Enemy_Pedestal");
+	Find_Closest_Poly_Position = (fcpp)Address(tt, "Find_Closest_Poly_Position");
+	Say_Dynamic_Dialogue = (sdd)Address(tt, "Say_Dynamic_Dialogue");
+	Say_Dynamic_Dialogue_Player = (sddp)Address(tt, "Say_Dynamic_Dialogue_Player");
+	Say_Dynamic_Dialogue_Team = (sddt)Address(tt, "Say_Dynamic_Dialogue_Team");
+	Enable_Letterbox_Player = (elp)Address(tt, "Enable_Letterbox_Player");
+	Create_Sound_Team = (cst)Address(tt, "Create_Sound_Team");
+	Create_2D_Sound_Team = (c2dst)Address(tt, "Create_2D_Sound_Team");
+	Create_2D_WAV_Sound_Team = (c2dwst)Address(tt, "Create_2D_WAV_Sound_Team");
+	Create_2D_WAV_Sound_Team_Dialog = (c2dwstd)Address(tt, "Create_2D_WAV_Sound_Team_Dialog");
+	Create_2D_WAV_Sound_Team_Cinematic = (c2dwstc)Address(tt, "Create_2D_WAV_Sound_Team_Cinematic");
+	Create_3D_WAV_Sound_At_Bone_Team = (c3dwsbt)Address(tt, "Create_3D_WAV_Sound_At_Bone_Team");
+	Create_3D_Sound_At_Bone_Team = (c3dsbt)Address(tt, "Create_3D_Sound_At_Bone_Team");
+	Stop_Sound_Player = (_Stop_Sound_Player)Address(tt, "Stop_Sound_Player");
+	Stop_Sound_Team = (_Stop_Sound_Team)Address(tt, "Stop_Sound_Team");
+	Set_Subobject_Animation = (ssa)Address(tt,"Set_Subobject_Animation");
+	Set_Time_Scale = (sts)Address(tt,"Set_Time_Scale");
+	Set_Subobject_Animation_Player = (ssap)Address(tt,"Set_Subobject_Animation_Player");
+	Write_File_Async = (wfa)Address(tt, "Write_File_Async");
 
 #ifdef SSGM
 	SSGMGameManager::Init();
diff -urN sourceold/scripts/dp88_ar.cpp source/scripts/dp88_ar.cpp
--- sourceold/scripts/dp88_ar.cpp	2018-11-17 10:23:57.137600000 +1000
+++ source/scripts/dp88_ar.cpp	2020-09-10 09:08:27.950898100 +1000
@@ -14,6 +14,7 @@
 #include "scripts.h"
 #include "engine.h"
 #include "dp88_ar.h"
+#include "ms.h"
 #include "Definition.h"
 #include "PurchaseSettingsDefClass.h"
 #include "SoldierGameObj.h"
@@ -1031,6 +1032,7 @@
 
     // Grant money to team and reset ore load level
     Commands->Give_Money ( obj, (float)m_oreValue, true );
+	MS_AccessHelper::Give_Bot_Credits(Get_Object_Type(obj), (float)m_oreValue);
     m_oreMined = 0;
     m_oreValue = 0;
 
@@ -1453,7 +1455,7 @@
 
       // OK, got a candidate zone, can we chronoshift here?
       Vector3 zonePos = Commands->Get_Position(zone);
-      if ( Commands->Get_Distance(zonePos,refineryPos) > maxDist || !CanChronoshiftToLocation(obj, zonePos) )
+      if (Vector3::Distance_Squared(zonePos, refineryPos) > maxDist * maxDist || !CanChronoshiftToLocation(obj, zonePos) )
         continue;
 
       // Is this zone in use for another chronoshift operation? If so then we cannot use it
@@ -3276,7 +3278,7 @@
 {
   // If we recieve a stop charging message from the tower we are currently
   // charging then we should stop all actions
-  if ( type == CUSTOM_PRISMTOWER_STOP_CHARGING && isAssistingTower && Commands->Get_ID(sender) == targetID )
+  if ( type == CUSTOM_PRISMTOWER_STOP_CHARGING && isAssistingTower && sender == m_target )
     StopAssisting(obj);
 
 
@@ -3286,12 +3288,12 @@
   else if ( type == CUSTOM_PRISMTOWER_REQUEST_CHARGING )
   {
     // Are we idle? If so then there's no reason not to simply start charging immediatly
-    if ( targetID == 0 )
+    if ( !m_target )
       StartAssisting(obj, sender, (float)param);
 
     // Is this request from the tower we are currently charging? If so then update the last seen
     // time and priority and forward the assistance request to any other adjacent towers
-    else if ( isAssistingTower && targetID == Commands->Get_ID(sender) )
+    else if ( isAssistingTower && m_target == sender )
     {
       targetLastSeen = (int)time(NULL);
       targetPriority = (float)param;
@@ -3319,7 +3321,7 @@
     *   Can this screw up the timings between charging towers and the attacking tower? Need to think
     *   this through sometime and possibly do some experimentation...
     */
-    if ( targetID )
+    if ( m_target )
       SendAssistanceRequests(obj);
 
     /* Refill a single unit of charge if depleted */
@@ -3327,7 +3329,7 @@
       Set_Current_Clip_Bullets(obj,1);
 
     /* If current bullets > 1 and no enemy seen recently then additional charge is lost */
-    if ( Get_Current_Bullets(obj) > 1 && targetID == 0 )
+    if ( Get_Current_Bullets(obj) > 1 && !m_target )
       Set_Current_Bullets(obj,1);
   }
 
@@ -3342,7 +3344,7 @@
 {
   // If the target is the tower we are currently charging then return
   // the priority of that charging sequence
-  if ( Commands->Get_ID(target) == targetID && isAssistingTower )
+  if ( m_target == target && isAssistingTower )
     return targetPriority;
 
   // Otherwise run the normal priority calculation
@@ -3354,7 +3356,7 @@
 bool dp88_AR_Prism_Tower::checkTeam( GameObject *obj, GameObject *target )
 {
   // Return true for the tower we are charging, even though it is on the same team as us
-  if ( Commands->Get_ID(target) == targetID && isAssistingTower )
+  if ( m_target == target && isAssistingTower )
     return true;
 
   // Otherwise run the normal check team function
@@ -3408,7 +3410,7 @@
 void dp88_AR_Prism_Tower::StartAssisting(GameObject* obj, GameObject* tower, float priority)
 {
   // Set our new target ID and priority
-  targetID = Commands->Get_ID(tower);
+  m_target = tower;
   targetPriority = priority;
   targetLastSeen = (int)time(NULL);
   isAssistingTower = true;
@@ -3427,7 +3429,7 @@
 {
   if ( isAssistingTower )
   {
-    targetID = NULL;
+    m_target = nullptr;
     targetPriority = 0;
     isAssistingTower = false;
     Commands->Action_Reset(obj, 101.0f);
@@ -3454,7 +3456,7 @@
   // Send out assistance requests to all adjacent towers except the one we are charging, if any
   for ( int i = 0; i < adjacentTowerCount; ++i )
   {
-    if ( adjacentTowers[i] != targetID && Commands->Find_Object(adjacentTowers[i]) != obj)
+    if ( adjacentTowers[i] != m_target->Get_ID() && Commands->Find_Object(adjacentTowers[i]) != obj)
       Commands->Send_Custom_Event(obj, Commands->Find_Object(adjacentTowers[i]), CUSTOM_PRISMTOWER_REQUEST_CHARGING, (int)targetPriority, 0.0f );
   }
 }
diff -urN sourceold/scripts/dp88_buildingScripts.cpp source/scripts/dp88_buildingScripts.cpp
--- sourceold/scripts/dp88_buildingScripts.cpp	2018-11-17 10:23:57.142600000 +1000
+++ source/scripts/dp88_buildingScripts.cpp	2020-03-28 21:10:59.018844900 +1000
@@ -15,6 +15,7 @@
 #include "engine.h"
 #include "dp88_custom_timer_defines.h"
 #include "dp88_buildingScripts.h"
+#include "ms.h"
 #include "definition.h"
 #include "BaseControllerClass.h"
 #include "WarFactoryGameObj.h"
@@ -1078,6 +1079,8 @@
 		int team = Get_Object_Type(obj);
 		if ( team == 0 || team == 1 )
 		{
+			MS_AccessHelper::Give_Bot_Credits(team, Get_Float_Parameter("creditsPerSec"));
+
 			// NB: Calling Give_Money with the building controller as a parameter doesn't seem
 			// to give anyone any money, so get the first player on the team and use them as
 			// the target for Give_Money (true as third param to give to whole team)
@@ -1102,6 +1105,8 @@
 {
 	if (team == 0 || team == 1)
 	{
+		MS_AccessHelper::Give_Bot_Credits(team, m_credits);
+
 		GameObject* pFirstPlayer = Find_First_Player(team);
 		if(pFirstPlayer)
 		{
